"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fromFile = void 0;
const get_pixels_1 = __importDefault(require("get-pixels"));
const util = __importStar(require("util"));
const x256_1 = __importDefault(require("x256"));
const getPixelsAsync = util.promisify(get_pixels_1.default);
const charPixel = "  ";
function bg256(r, g, b) {
    return escaped(48, 5, (0, x256_1.default)(r, g, b));
}
function bgTrueColor(r, g, b) {
    return escaped(48, 2, r, g, b);
}
const bgClear = escaped(0);
function escaped(...str) {
    const txt = str.join(";");
    return `\x1b[${txt}m`;
}
function bg(trueColor, r, g, b, a) {
    if (a < 255) {
        return bgClear;
    }
    if (trueColor) {
        return bgTrueColor(r, g, b);
    }
    return bg256(r, g, b);
}
function fromPixels(pixels, opts) {
    // Grab the first frame of an animated GIF.
    if (pixels.shape.length === 4) {
        pixels = pixels.pick(0, null, null, null);
    }
    const [width, height] = pixels.shape;
    let ret = "";
    if (opts.padding) {
        ret += "\n";
    }
    for (let j = 0; j < height; j++) {
        ret += bgClear;
        if (opts.padding) {
            ret += charPixel;
        }
        for (let i = 0; i < width; i++) {
            const r = pixels.get(i, j, 0);
            const g = pixels.get(i, j, 1);
            const b = pixels.get(i, j, 2);
            const a = pixels.get(i, j, 3);
            ret += bg(opts.trueColor, r, g, b, a);
            ret += charPixel;
        }
        ret += bgClear;
        ret += "\n";
    }
    return ret;
}
async function fromFile(file, opts) {
    const pixels = await getPixelsAsync(file, "");
    return fromPixels(pixels, opts);
}
exports.fromFile = fromFile;
